* ********************************************************************
* TBDATA - DSECTs for TBMASTER and TBCHILD programs
*
* Copyright IBM(UK) Ltd 2014
* HLASM - High Level Assembler and Toolkit (5696-234)
*
* IBM HLASM - Transactional-Execution Facility Technote
*
* This COPYBOOK is used to provide the TBMSTR and TBCHILD programs
* with a common set of data structures.
*
* The TB_MASTER DSECT is the data area which is passed from the
* master program to the child programs.
*
* The format of memory areas obtained from the 1st and 2nd subpool is
* defined by the TB_SP1_PARM and TB_SP2_PARM DSECTs and are used by
* the child programs in order to build storage chains.
*
* ********************************************************************
TB_MASTER       DSECT ,                 Area passed to children tasks
TB_EYE          DC CL(C_EYE_LENGTH)' '  Eye catcher
TB_CELL_ID_1    DC F'0'                 cell poolid
TB_CELL_ID_2    DC F'0'                 cell poolid
TB_ENQ_COUNT_1  DC F'0'                 Number of ...
TB_DEQ_COUNT_1  DC F'0'                 Number of ...
TB_CELL_COUNT_1 DC F'0'                 Number of cells
TB_CELL_COUNT_2 DC F'0'                 Number of cells
TB_ATTA_COUNT   DC F'0'                 Attach count
TB_DETA_COUNT   DC F'0'                 Dettach count
TB_CELL_CHAIN_1 DC A(0)                 cell poolid
TB_CELL_CHAIN_2 DC A(0)                 cell poolid
TB_TRAN_SUPPORT DC C'N'                 Trans support availability
                DC 0D                   align eye
TB_FCLTY_LIST   DC 2FD'0'               Faciliy list
TB_EYE_E        DC CL(C_EYE_LENGTH)' '  Eye catcher
                DC 0D
TB_LENGTH       EQU *-TB_MASTER
* ********************************************************************
TB_SP1_PARM    DSECT ,                  Subpool 1
SP1_EYE        DC CL(C_EYE_LENGTH)' '   Eye catcher
SP1_TCB        DC A(0)                  Pointer to TCB
SP1_F_PTR      DC A(0)                  Pointer to next cell
               DC 0D
SP1_LENGTH     EQU *-TB_SP1_PARM
* ********************************************************************
TB_SP2_PARM    DSECT ,                  Subpool 2
SP2_EYE        DC CL(C_EYE_LENGTH)' '   Eye catcher
SP2_TCB        DC A(0)                  Pointer to TCB
SP2_F_PTR      DC A(0)                  Pointer to next cell
               DC 0D
SP2_LENGTH     EQU *-TB_SP2_PARM
