TBMSTR   RSECT
TBMSTR   RMODE  ANY
TBMSTR   AMODE  31
* ********************************************************************
* TBMSTR - Master transaction program
*
* Copyright IBM(UK) Ltd 2014
* HLASM - High Level Assembler and Toolkit (5696-234)
*
* The purpose of this program is to spawn child processes in order to
* build linked lists.
* The number of child processes spawned is determined by the
* C_CHILD_COUNT equate.
*
* ********************************************************************
         COPY  ASMMSP
         ASMDREG
         ASMMREL
C_EYE_LENGTH  EQU 16
C_CHILD_COUNT EQU 100               Amount of child threads to create
         PRINT OFF
         SYSSTATE ARCHLVL=1
         IEABRCX  DEFINE
         PRINT ON
         IHAPSA   ,
*
* ********************************************************************
* Start of mainline code
* ********************************************************************
*
TBMSTR   RSECT    ,
         PRINT ON
         SAVE (14,12),,*
         LARL  R9,STATICAREA
         USING (STATICAREA,STATICAREA_E),R9
         LA    R2,WS_LENGTH
         STORAGE OBTAIN,LENGTH=(R2),ADDR=(R3),COND=NO
         USING (WORKING_STORAGE,WORKING_STORAGE+WS_LENGTH),R3
         ST    R13,WS_SAVEA+4       save callers savearea
         LA    R13,WS_SAVEA         address my savearea
         ST    R13,WS_SAVEA+8       .. and save it
         MVC   WS_EYE,=CL(C_EYE_LENGTH)'TBMSTR W/S->'
         MVC   WS_EYE_E,=CL(C_EYE_LENGTH)'TBMSTR W/S-<'
         USING TB_MASTER,WS_MASTER_DATA
         MVC   TB_EYE,=CL(C_EYE_LENGTH)'TBMSTR MASTER>'
         MVC   TB_EYE_E,=CL(C_EYE_LENGTH)'<TBMSTR MASTER'
         MVI   TB_TRAN_SUPPORT,C'N'
         XC    TB_FCLTY_LIST,TB_FCLTY_LIST
         MVC   WS_LOAD(S_LOAD_L),S_LOAD
*
* Setup WTOs showing transactional execution facility
*
         MVC   WS_WTO_SUPPORT_Y(S_WTO_SUPPORT_YL),S_WTO_SUPPORT_Y
         MVC   WS_WTO_SUPPORT_C(S_WTO_SUPPORT_CL),S_WTO_SUPPORT_C
         MVC   WS_WTO_SUPPORT_N(S_WTO_SUPPORT_NL),S_WTO_SUPPORT_N
         MVC   WS_WTO_ENDED(S_WTO_ENDED_L),S_WTO_ENDED
*
         MVC   WS_ATTACHX(S_ATTACHX_L),S_ATTACHX
         MVC   WS_POOL_1(S_POOL_1_L),S_POOL_1
         MVC   WS_POOL_2(S_POOL_2_L),S_POOL_2
*
* Check for the availability of the transaction facility
* This is located in bits 73 and 50 of the result of the STFLE
* instruction.
* Bit 73 must be checked first and indicates the presence of the
* Transactional-Execution Facility.
* Bit 50 may be checked once it is know that the transactional
* execution facility is available on this machine and indicates the
* Constrained transactional execution facility is available.
*
* If you wish to build the program so that it does not use the
* transactional execution facility then uncomment the line marked
* ########
*        AGO   .B_LOAD                         #######
         XR    R0,R0
         USING PSA,R0
         TM    FLCEFACILITIESLISTBYTE9,X'40'   Test for trans facility
         IF    (O)                             Is it on?
           MVI   TB_TRAN_SUPPORT,C'Y'          Yes - non-constr enabld
           WTO   MF=(E,WS_WTO_SUPPORT_Y)
           TM    FLCEFACILITIESLISTBYTE6,X'20' Constr trans avavilable?
           IF    (O)
             MVI   TB_TRAN_SUPPORT,C'C'        Yes - constr trans on
             WTO    MF=(E,WS_WTO_SUPPORT_C)
           ENDIF ,
         ELSE  ,
           CLI   TB_TRAN_SUPPORT,C'N'          Unknown value?
           JNE   CABEND                        Yes - ABEND
           WTO   MF=(E,WS_WTO_SUPPORT_N)       Indicate no tran
         ENDIF ,
         DROP  R0
.B_LOAD  ANOP  ,                               ########################
*
* Load and start the child programs TBCHILD.
* After the child programs have been started, TBMSTR will wait until
* the child programs finish their processing.
*
BEGLOAD  LOAD  EP=TBCHILD,                                             X
               SF=(E,WS_LOAD)
         ST    R0,WS_TBCHILD_EP
         ST    R1,WS_TBCHILD_LP
         CPOOL BUILD,PCELLCT=10,SCELLCT=5,                             X
               CSIZE=128,SP=0,LOC=31,                                  X
               CPID=TB_CELL_ID_1,                                      X
               HDR='TBMSTR CPOOL ONE',                                 X
               MF=(E,WS_POOL_1)
         CPOOL BUILD,PCELLCT=8,SCELLCT=12,                             X
               CSIZE=64,SP=0,LOC=31,                                   X
               CPID=TB_CELL_ID_2,                                      X
               HDR='TBMSTR CPOOL TWO',                                 X
               MF=(E,WS_POOL_2)
         XR    R5,R5
         LA    R6,C_CHILD_COUNT
         LA    R7,WS_ECB_CHILD
         LA    R8,WS_TCB_CHILD
NextAttach DC 0H
         ATTACHX EP=TBCHILD,PARAM=TB_MASTER,                           X
               ECB=(R7),                                               X
               SF=(E,WS_ATTACHX),MF=(E,WS_TBCHILD_PL)
         ST    R1,0(,R8)
         LA    R7,L'WS_ECB_CHILD(,R7)
         LA    R8,L'WS_TCB_CHILD(,R8)
         AFI   R5,1
         BCT   R6,NextAttach
         ST    R5,TB_ATTA_COUNT
         XR    R5,R5
         LA    R6,C_CHILD_COUNT
         LA    R7,WS_ECB_CHILD
         LA    R8,WS_TCB_CHILD
NextEndAndDetach DC 0H
         WAIT  1,ECB=(R7)
         DETACH (R8)
         LA    R7,L'WS_ECB_CHILD(,R7)
         LA    R8,L'WS_TCB_CHILD(,R8)
         AFI   R5,1
         BCT   R6,NextEndAndDetach
         ST    R5,TB_DETA_COUNT
CLEANUP  DC    0H
         DELETE EPLOC=WS_TBCHILD_EP
         CPOOL DELETE,                                                 X
               CPID=TB_CELL_ID_1
         CPOOL DELETE,                                                 X
               CPID=TB_CELL_ID_2
*
* At this stage, the child processes have completed processing.
* TBMSTR releases its storage and returns control to the OS.
*
EXIT     DC    0H                    exit label
         WTO   MF=(E,WS_WTO_ENDED)
         L     R13,WS_SAVEA+4       restore callers savearea
         LA    R2,WS_LENGTH
         STORAGE RELEASE,LENGTH=(R2),ADDR=(R3),COND=NO
         RETURN (14,12),,RC=0     return
CABEND         DC 20X'0'
*
* ********************************************************************
* Static storage used by TBMSTR
* ********************************************************************
*
STATICAREA       DC 0D'0'           align storage
*
* Static macro definitions
*
S_LOAD           LOAD  SF=L
S_LOAD_L         EQU   *-S_LOAD
S_ATTACHX        ATTACHX SF=L
S_ATTACHX_L      EQU *-S_ATTACHX
S_POOL_1         CPOOL BUILD,MF=L
S_POOL_1_L       EQU *-S_POOL_1
S_POOL_2         CPOOL BUILD,MF=L
S_POOL_2_L       EQU *-S_POOL_2
*
S_CHILD_NAME     DC  CL8'TBCHILD'
*
* WTO messages for static storage
*
S_WTO_SUPPORT_Y  WTO 'Transactionality available',MF=L
S_WTO_SUPPORT_YL EQU *-S_WTO_SUPPORT_Y
S_WTO_SUPPORT_C  WTO 'Constrained Transactionality available',MF=L
S_WTO_SUPPORT_CL EQU *-S_WTO_SUPPORT_C
S_WTO_SUPPORT_N  WTO 'No transactionality available',MF=L
S_WTO_SUPPORT_NL EQU *-S_WTO_SUPPORT_C
S_WTO_ENDED      WTO 'Master process ended',MF=L
S_WTO_ENDED_L    EQU  *-S_WTO_ENDED
*
                 LTORG ,
STATICAREA_E     DC 0D'0'           align storage - end of static
*
* ********************************************************************
* Working storage used by TBMSTR
* ********************************************************************
*
WORKING_STORAGE DSECT             Program dynamic area
WS_EYE         DC CL(C_EYE_LENGTH)' '    Eye catcher
WS_SAVEA       DC 18F'00'                save area
WS_LOAD        DC 0D,XL(S_LOAD_L)'00'    load macro
WS_ATTACHX     DC 0D,XL(S_ATTACHX_L)'00' Attachx
WS_POOL_1      DC 0D,XL(S_POOL_1_L)'00'  cpool 1
WS_POOL_2      DC 0D,XL(S_POOL_2_L)'00'  cpool 2
*
* WS WTO buffers for transaction support
*
WS_WTO_SUPPORT_Y  DC 0D,XL(S_WTO_SUPPORT_YL)'00'
WS_WTO_SUPPORT_C  DC 0D,XL(S_WTO_SUPPORT_CL)'00'
WS_WTO_SUPPORT_N  DC 0D,XL(S_WTO_SUPPORT_NL)'00'
WS_WTO_ENDED      DC 0D,XL(S_WTO_ENDED_L)'00'
*
WS_TBCHILD_EP  DC A(0)            child program address
WS_TBCHILD_LP  DC A(0)            child program address
WS_TBCHILD_PL  DC A(0)            child program address
WS_TCB_CHILD   DC (C_CHILD_COUNT)F'00'           TCB
WS_ECB_CHILD   DC (C_CHILD_COUNT)F'00'           ECB
WS_COUNTER     DC F'00'           ws counter
               DC 0D              align end
WS_MASTER_DATA DC XL(TB_LENGTH)'00'
WS_EYE_E       DC CL(C_EYE_LENGTH)' '    Eye catcher
WS_LENGTH      EQU *-WORKING_STORAGE WS Length
         COPY TBDATA
         END   TBMSTR
